var Property, check, keys, round, test, _default, makeError, failed, abandoned, percentage, display, fact, o;
Property = require('claire/lib/property').Property;
check = require('claire/lib/check').check;
keys = Object.keys;
round = Math.round;
test = global.it;
_default = {
  times: 100,
  verbose: false
};
makeError = curry$(function(name, message){
  var ref$;
  return ref$ = Error.call({}, message), ref$.name = name, ref$;
});
failed = function(report){
  return makeError('property-failed', report + "");
};
abandoned = function(report){
  return makeError('property-abandoned', report + "");
};
percentage = function(n, total){
  return round((n / total) * 100);
};
display = curry$(function(verbose, report){
  var text, total, ignored, ignoredPct, hasLabels;
  text = (report + "").split(/\n/).map(function(s){
    return "  " + s;
  }).join('\n');
  total = report.all.length;
  ignored = report.ignored.length;
  ignoredPct = percentage(ignored, total);
  hasLabels = !!keys(report.labels).length;
  if (verbose || ignoredPct > 50 || hasLabels) {
    return typeof console != 'undefined' && console !== null ? console.log(text) : void 8;
  }
});
fact = curry$(function(c, p){
  return function(){
    var report;
    report = check(c.times || 100, p);
    switch (report.verdict) {
    case 'passed':
      return display(c.verbose, report);
    case 'failed':
      throw failed(report);
    case 'abandoned':
      throw abandoned(report);
    }
  };
});
o = curry$(function(label, p){
  return test(label, fact(global.claireConfig || _default, p()));
});
module.exports = {
  fact: fact,
  o: o
};
function curry$(f, bound){
  var context,
  _curry = function(args) {
    return f.length > 1 ? function(){
      var params = args ? args.concat() : [];
      context = bound ? context || this : this;
      return params.push.apply(params, arguments) <
          f.length && arguments.length ?
        _curry.call(context, params) : f.apply(context, params);
    } : f;
  };
  return _curry();
}
